def(prob_master(M0, M1, M2, P, N), 
	prob_choice([pref(tau(0.25), pref(out(M0, P), pref(out(M1, N), pref(out(M2, N), zero)))), 
		     pref(tau(0.25), pref(out(M0, N), pref(out(M1, P), pref(out(M2, N), zero)))),
		     pref(tau(0.25), pref(out(M0, N), pref(out(M1, N), pref(out(M2, P), zero)))),
		     pref(tau(0.25), pref(out(M0, N), pref(out(M1, N), pref(out(M2, N), zero))))])).

def(master(M0, M1, M2, P, N), 
	choice([pref(tau, pref(out(M0, P), pref(out(M1, N), pref(out(M2, N), zero)))), 
		pref(tau, pref(out(M0, N), pref(out(M1, P), pref(out(M2, N), zero)))),
		pref(tau, pref(out(M0, N), pref(out(M1, N), pref(out(M2, P), zero)))),
		pref(tau, pref(out(M0, N), pref(out(M1, N), pref(out(M2, N), zero))))])).

def(crypt(M, S0, S1, C0, C1, P, N, PAY, OUT, AGREE, DISAGREE, HEAD, TAIL, NULL),
	pref(in(M, X), pref(out(S0, NULL), pref(out(S1, NULL), pref(in(C0, Y), pref(in(C1, Z),
	choice([match((X=P),  
		pref(out(PAY, NULL),
		choice([match((Y=HEAD), match((Z=HEAD), pref(out(OUT, DISAGREE), zero))),
			match((Y=TAIL), match((Z=TAIL), pref(out(OUT, DISAGREE), zero))),
			match((Y=HEAD), match((Z=TAIL), pref(out(OUT, AGREE), zero))),
			match((Y=TAIL), match((Z=HEAD), pref(out(OUT, AGREE), zero)))]))),
		match((X=N), 		
		choice([match((Y=HEAD), match((Z=HEAD), pref(out(OUT, AGREE), zero))),
			match((Y=TAIL), match((Z=TAIL), pref(out(OUT, AGREE), zero))),
			match((Y=HEAD), match((Z=TAIL), pref(out(OUT, DISAGREE), zero))),
			match((Y=TAIL), match((Z=HEAD), pref(out(OUT, DISAGREE), zero)))]))]))))))).

def(face(C0, C1, F), 
	pref(out(C0, F), pref(out(C1, F), zero))).

def(coin(S0, S1, C0, C1, HEAD, TAIL, PROB_HEADS, PROB_TAILS), 
	pref(in(S0, _), pref(in(S1, _),
	prob_choice([pref(tau(PROB_HEADS), proc(face(C0, C1, HEAD))), 
		     pref(tau(PROB_TAILS), proc(face(C0, C1, TAIL)))])))).

def(dcp(PAY0, PAY1, PAY2, OUT0, OUT1, OUT2, AGREE, DISAGREE, HEAD, TAIL, P, N, NULL), 
	nu1(M0, nu1(M1, nu1(M2,
	par(proc(master(M0, M1, M2, P, N)),
	nu1(S00, nu1(S01, nu1(S11, nu1(S12, nu1(S22, nu1(S20,
	nu1(C00, nu1(C01, nu1(C11, nu1(C12, nu1(C22, nu1(C20,
		par(proc(crypt(M0, S00, S01, C00, C01, P, N, PAY0, OUT0, AGREE, DISAGREE, HEAD, TAIL, NULL)),
		par(proc(crypt(M1, S11, S12, C11, C12, P, N, PAY1, OUT1, AGREE, DISAGREE, HEAD, TAIL, NULL)),
		par(proc(crypt(M2, S22, S20, C22, C20, P, N, PAY2, OUT2, AGREE, DISAGREE, HEAD, TAIL, NULL)),
		par(proc(coin(S00, S20, C00, C20, HEAD, TAIL)),
		par(proc(coin(S11, S01, C11, C01, HEAD, TAIL)),
		    proc(coin(S22, S12, C22, C12, HEAD, TAIL)))))))))))))))))))))))).

test:-
	stg_log(master(m0, m1, m2, p, n)),
	stg_log(crypt(m0, s00, s01, c00, c01, p, n, pay0, out0, agree, disagree, head, tail, null)),
	stg_log(coin(s00, s20, c00, c20, head, tail, '1/3', '2/3')).
	