def(master(M0, M1, M2, P, N), 
	choice([pref(tau, pref(out(M0, P), pref(out(M1, N), pref(out(M2, N), zero)))), 
		pref(tau, pref(out(M0, N), pref(out(M1, P), pref(out(M2, N), zero)))),
		pref(tau, pref(out(M0, N), pref(out(M1, N), pref(out(M2, P), zero))))])).
%		pref(tau, pref(out(M0, N), pref(out(M1, N), pref(out(M2, N), zero))))])).

def(crypt(M, C0, C1, P, N, PAY, OUT, AGREE, DISAGREE, HEAD, TAIL, NULL, PROB_HEAD, PROB_TAIL),
	pref(in(M, X),
	prob_choice([pref(tau(PROB_HEAD), 
		     choice([pref(in(C0, Y), pref(out(C1, HEAD), proc(pay(X, Y, HEAD, P, N, PAY, OUT, AGREE, DISAGREE, HEAD, TAIL, NULL)))),
		             pref(out(C1, HEAD), pref(in(C0, Y), proc(pay(X, Y, HEAD, P, N, PAY, OUT, AGREE, DISAGREE, HEAD, TAIL, NULL))))])),
		     pref(tau(PROB_TAIL), 
		     choice([pref(in(C0, Y), pref(out(C1, TAIL), proc(pay(X, Y, TAIL, P, N, PAY, OUT, AGREE, DISAGREE, HEAD, TAIL, NULL)))),
		             pref(out(C1, TAIL), pref(in(C0, Y), proc(pay(X, Y, TAIL, P, N, PAY, OUT, AGREE, DISAGREE, HEAD, TAIL, NULL))))]))]))).

def(pay(X, Y, Z, P, N, PAY, OUT, AGREE, DISAGREE, HEAD, TAIL, NULL),
	par(match((X=P),  
		pref(out(PAY, NULL),
		par(match((Y=HEAD), match((Z=HEAD), 
			pref(out(OUT, DISAGREE), zero))),
		par(match((Y=TAIL), match((Z=TAIL),
			pref(out(OUT, DISAGREE), zero))),
		par(match((Y=HEAD), match((Z=TAIL),
			pref(out(OUT, AGREE), zero))),
		    match((Y=TAIL), match((Z=HEAD),
			pref(out(OUT, AGREE), zero)))))))),
	    match((X=N), 		
		par(match((Y=HEAD), match((Z=HEAD), 
			pref(out(OUT, AGREE), zero))),
		par(match((Y=TAIL), match((Z=TAIL),
			pref(out(OUT, AGREE), zero))),
		par(match((Y=HEAD), match((Z=TAIL),
			pref(out(OUT, DISAGREE), zero))),
		    match((Y=TAIL), match((Z=HEAD),
			pref(out(OUT, DISAGREE), zero))))))))).

def(dcp(PAY0, PAY1, PAY2, OUT0, OUT1, OUT2, AGREE, DISAGREE, HEAD, TAIL, P, N, NULL, PROB_HEAD, PROB_TAIL), 
	nu1(M0, nu1(M1, nu1(M2,
	par(proc(master(M0, M1, M2, P, N)),
	nu1(C0, nu1(C1, nu1(C2,
		par(proc(crypt(M0, C2, C0, P, N, PAY0, OUT0, AGREE, DISAGREE, HEAD, TAIL, NULL, PROB_HEAD, PROB_TAIL)),
		par(proc(crypt(M1, C0, C1, P, N, PAY1, OUT1, AGREE, DISAGREE, HEAD, TAIL, NULL, PROB_HEAD, PROB_TAIL)),
		par(proc(crypt(M2, C1, C2, P, N, PAY2, OUT2, AGREE, DISAGREE, HEAD, TAIL, NULL, PROB_HEAD, PROB_TAIL))))))))))))).

test:-
	stg_log(master(m0, m1, m2, p, n)),
	stg_log(crypt(m0, c0, c1, p, n, pay0, out0, agree, disagree, head, tail, null, bias, 1-bias)),
	stg_log(dcp(pay0, pay1, pay2, out0, out1, out2, agree, disagree, head, tail, p, n, null, bias, 1-bias)).
	